<template>
  <div class="page">
    <div
      class="back-link"
      @click="$router.push({ name: 'Accounts' })"
    >
      <b-icon-chevron-left font-scale="1.3" />
      <span>
        Gestion des comptes
      </span>
    </div>
    <div class="top">
      <b-row>
        <b-col class="left-col">
          <span>
            <img
              src="@/assets/icons/company.svg"
              alt="Icône organisation"
            />
            {{ organisationsCount }} organisations
          </span>
          <div
            class="add-btn"
            @click="$router.push({ name: 'AddOrganisation' })"
          >
            <b-icon-plus />
            Créer une organisation
          </div>
          <SearchTable
            :placeholder="'Rechercher une organisation'"
            :searchFunction="SEARCH_ORGANISATIONS_LIST"
            @loading="loadSearch"
          />
        </b-col>
        <b-col class="right-col">
          <TableFilters
            :filter-name="'usergroup__status__in'"
            @filter="setTableFilters"
          />
        </b-col>
      </b-row>
    </div>
    <div class="custom-table">
      <b-overlay
        :show="loading"
        :variant="'white'"
        :opacity="0.7"
        rounded="sm"
      >
        <template #overlay>
          <div class="d-flex align-items-center">
            <b-spinner variant="secondary"></b-spinner>
          </div>
        </template>
        <CustomTable
          :routeTo="'OrganisationDetail'"
          :fields="fields"
          :items="items"
          :sortFunction="GET_ORGANISATIONS_LIST"
          :selectable="false"
          @sorted="setTableSorted"
          @delete="openDeleteModal"
          @loading="setTableLoader"
        />
        <Pagination
          v-if="organisationsCount > 50"
          :nbPages="Math.ceil(organisationsCount/50)"
          @change-page="changeTablePage"
        />
      </b-overlay>
    </div>
    <DeleteOrganisation
      :open="deletingOrganisation"
      :organisation="organisationToDelete"
      @hide="deletingOrganisation = false"
      @update="updateOrganisationsList"
    />
  </div>
</template>

<script>
import CustomTable from '@/components/CustomTable.vue';
import Pagination from '@/components/Pagination.vue';
import SearchTable from '@/components/SearchTable.vue';
import DeleteOrganisation from '@/components/Modals/DeleteOrganisation.vue';
import TableFilters from '@/components/TableFilters.vue';

import { mapState, mapMutations, mapActions } from 'vuex';

export default {
  name: 'Organisations',

  components: {
    CustomTable,
    Pagination,
    SearchTable,
    DeleteOrganisation,
    TableFilters
  },

  data() {
    return {
      loading: false,
      deletingOrganisation: false,
      organisationToDelete: null,
      fields: [
        {
          key: 'Organisation',
          apiName: 'display_name',
          sortable: true,
          width: '20%',
          centered: false
        },
        {
          key: 'Type d\'organisation',
          apiName: 'organisation_type',
          sortable: true,
          width: '15%',
          centered: false
        },
        {
          key: 'Date de création',
          apiName: 'creation_date',
          sortable: true,
          width: '',
          centered: true
        },
        {
          key: 'Nombre d\'utilisateurs',
          sortable: false,
          width: '15%',
          centered: true
        },
        {
          key: 'Convention signée',
          sortable: false,
          width: '',
          centered: true
        },
        {
          key: 'Convention',
          sortable: false,
          width: '8%',
          centered: true
        },
        {
          key: 'Statut',
          sortable: false,
          width: '6%',
          centered: true
        },
        {
          key: 'Supprimer',
          sortable: false,
          width: '8%',
          centered: true
        }
      ],
      tableSorted: {
        direction: null,
        field: null
      }
    };
  },

  computed: {
    ...mapState('organisations', [
      'organisationsList',
      'organisationsCount',
      'organisationsTypes',
      'isOrganisationsListSearched',
      'searchOrganisationsFilter'
    ]),
    items() {
      return this.organisationsList.map(el => {
        return {
          id: el.id,
          'Organisation': el.display_name,
          'Type d\'organisation': el.organisation_type ? el.organisation_type.display_name : '',
          'Date de création': new Date(el.creation_date).toLocaleString('fr-FR', {year: "numeric", month: "long", day: "numeric"}),
          'Nombre d\'utilisateurs': el.usergroup.members_count,
          'Convention signée': el.agreement_signed,
          'Convention': el.agreement_file ? el.agreement_file.url : null,
          'Statut': [
            {choice: 0, value: 'secondary'},
            {choice: 1, value: 'warning'},
            {choice: 2, value: 'success'}
          ].find(item => item.choice === el.usergroup.status).value,
        }
      });
    }
  },

  created() {
    // Reset filters
    this.SET_CURRENT_PAGE(1);
    this.setTableFilters({
      filter: 'usergroup__status__in',
      values: [
        {status: '2', state: true},
        {status: '1', state: false},
        {status: '0', state: false}
      ]
    })
    // Get data if data not loaded already filtered by search
    if (this.organisationsTypes.length === 0) {
      this.getConfigData();
    }
    if (this.organisationsList.length === 0 || this.isOrganisationsListSearched) {
      this.getData();
    }
  },

  mounted() {
    // Watch modal closing event
    this.$root.$on('bv::modal::hide', () => {
      this.deletingOrganisation = false
    });
  },

  methods: {
    ...mapActions('organisations', [
      'GET_ORGANISATIONS_LIST',
      'SEARCH_ORGANISATIONS_LIST',
      'GET_ORGANISATIONS_TYPES',
      'PRESET_ORGANISATIONS_FILTERS',
      'PREREMOVE_ORGANISATIONS_FILTERS'
    ]),
    ...mapMutations('pagination', [
      'SET_CURRENT_PAGE'
    ]),

    getConfigData() {
      this.GET_ORGANISATIONS_TYPES();
    },

    getData() {
      this.loading = true;
      this.GET_ORGANISATIONS_LIST({...this.tableSorted}).then(() => {
        this.loading = false;
      });
    },

    openDeleteModal(e) {
      this.deletingOrganisation = true;
      this.organisationToDelete = e;
    },

    updateOrganisationsList() {
      this.getData();
    },

    changeTablePage(e) {
      this.loading = true;
      this.GET_ORGANISATIONS_LIST({...this.tableSorted, page: e}).then(() => {
        this.loading = false;
      });
    },

    setTableLoader(e) {
      this.loading = e;
    },

    setTableSorted(e) {
      this.tableSorted = e;
    },

    loadSearch(e) {
      this.loading = e;
    },

    setTableFilters(e) {
      for (const filter of e.values) {
        if (filter.state) {
          this.PRESET_ORGANISATIONS_FILTERS({
            filter: e.filter,
            value: filter.status
          });
        } else {
          this.PREREMOVE_ORGANISATIONS_FILTERS({
            filter: e.filter,
            value: filter.status
          });
        }
      }
      this.loading = true;
      if (!this.isOrganisationsListSearched) {
        this.GET_ORGANISATIONS_LIST({...this.tableSorted})
        .then(() => {
          this.loading = false;
        });
      } else {
        this.SEARCH_ORGANISATIONS_LIST({
          text: this.searchOrganisationsFilter,
          ordering: {...this.tableSorted}
        }).then(() => {
          this.loading = false;
        });
      }
    }
  }
}
</script>

<style lang="less" scoped>

.b-overlay {
  .position-absolute {
    display: flex;
  }
}

</style>
